'''
定义表的结构，并在数据库中创建对应的数据表
'''
__author__ = 'lmstack'

from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy import Column, String, create_engine, Integer, DateTime, BigInteger, FLOAT, TIMESTAMP, func, Text
from urllib import parse
Base = declarative_base()


class ConsistencyDeltaSoc(Base):
    __tablename__ = "mechanism_sorout"
    __table_args__ = ({'comment': '电压内阻偏离检测'})  # 添加索引和表注释

    id = Column(Integer, primary_key=True, autoincrement=True, comment="主键")
    add_time = Column(TIMESTAMP(True), comment='记录创建时间') # 创建时间
    update_time = Column(TIMESTAMP(True), nullable=False, server_default=func.now(), onupdate=func.now(), comment='记录更新时间') # 更新时间
    
    sn = Column(String(64), comment="sn")
    time = Column(TIMESTAMP(True), comment="计算时刻")
    sor = Column(Text, comment="内阻")
    sor_sigma = Column(Text, comment="内阻偏离度")
    soc = Column(Text, comment="soc")
    temp = Column(Text, comment="temp")
    delta_time = Column(FLOAT, comment="放电时长")


    # def __init__(self, sn, current, time_stamp, pack_state, line_state):
    #     self.sn = sn
    #     self.current = current
    #     self.time_stamp = time_stamp
    #     self.pack_state = pack_state
    #     self.line_state = line_state

# 执行该文件，创建表格到对应的数据库中
if __name__ == "__main__":
    host = 'rm-bp10j10qy42bzy0q77o.mysql.rds.aliyuncs.com'
    port = 3306
    user = 'qx_cas'
    password = parse.quote_plus('Qx@123456')
    database = 'qx_cas'
    
    db_engine = create_engine(
        "mysql+pymysql://{}:{}@{}:{}/{}?charset=utf8".format(
            user, password, host, port, database
        ))
    Base.metadata.create_all(db_engine)