import datetime
import pandas as pd
from LIB.BACKEND import DBManager, Log
import time, datetime
from apscheduler.schedulers.blocking import BlockingScheduler
from pandas.core.frame import DataFrame
import matplotlib as plt
from pylab import*
import vol_sor_est
from LIB.MIDDLE.CellStateEstimation.Common.V1_0_1 import BatParam
import log

#...................................电池包电芯安全诊断函数......................................................................................................................
def cell_volsor_test():
    global SNnums
    global df_diag_sor
    global df_diag_vol
    global df_diag_volsor
    start=time.time()
    now_time=datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')
    now_time=datetime.datetime.strptime(now_time,'%Y-%m-%d %H:%M:%S')
    start_time=now_time-datetime.timedelta(days=3)
    end_time=str(now_time)
    start_time=str(start_time)
    k = 1
    for sn in SNnums:
        if 'PK500' in sn:
            celltype=1 #6040三元电芯
        elif 'PK502' in sn:
            celltype=2 #4840三元电芯
        elif 'K504B' in sn:
            celltype=99    #60ah林磷酸铁锂电芯
        elif 'MGMLXN750' in sn:
            celltype=3 #力信50ah三元电芯
        elif ('MGMCLN750' or 'UD') in sn: 
            celltype=4 #CATL 50ah三元电芯
        elif 'TJMCL' in sn: 
            celltype=100 #金茂电芯
        else:
            print('SN：{}，未找到对应电池类型！！！'.format(sn))
            continue
            # sys.exit()
        print('计算的第' + str(k) + '个:' + sn)
        k = k + 1
        #读取原始数据库数据........................................................................................................................................................
        start_time = '2021-12-01 00:00:00'
        end_time = '2021-12-04 00:00:00'
        dbManager = DBManager.DBManager()
        df_data = dbManager.get_data(sn = sn, start_time = start_time, end_time = end_time, data_groups = ['bms'])
        df_bms = df_data['bms']
        df_del_sor_add = pd.DataFrame()
        df_del_vol_add = pd.DataFrame()
        df_diag_sor_add = pd.DataFrame()
        df_diag_vol_add = pd.DataFrame() 
        param = BatParam.BatParam(celltype)#鹏飞param中为BatParam，学琦为BatteryInfo
        cellvolt_name=['单体电压'+str(x) for x in range(1,param.CellVoltNums+1)]
        #........................................................电压内阻估计.....................................................................
        if not df_bms.empty:
            Diag_sorvol_temp = vol_sor_est.vol_sor_est(sn,celltype,df_bms)#电压内阻估计
            [df_del_sor_add, df_del_vol_add, df_diag_sor_add, df_diag_vol_add, df_diag_sorvol_add] = Diag_sorvol_temp.volsor_cal()        
            if not df_del_sor_add.empty:
                #..................................................估计电压内阻作图.........................................................
                m = max(df_del_sor_add['dischrgr_num'] + 1)
                for i in range(1,m):#m
                    df_time_data = []
                    fig = plt.figure(figsize=(20,10))
                    df_fig = df_del_sor_add.loc[df_del_sor_add['dischrgr_num'] == i]
                    df_fig.reset_index(drop = True, inplace = True)
                    length = len(df_fig)
                    df_time = pd.to_datetime(df_fig['时间戳'])
                    for df_time_num in range(0, length):
                        df_time_data.append(df_time[df_time_num].strftime('%H:%M:%S'))
                    for volt_num in cellvolt_name:
                        plt.plot(df_time_data, df_fig[volt_num],linewidth = 2, linestyle = '-', marker = 's',label=volt_num)
                    mpl.rcParams['font.sans-serif']=['SimHei']
                    mpl.rcParams['axes.unicode_minus']=False #用来正常显示负号
                    plt.legend(fontsize=18)
                    title = sn + '-内阻估计' + df_time[0].strftime('%Y-%m-%d') #df_fig['device_id'][0] + '-' + 
                    plt.xlabel('时间', fontsize=24)
                    plt.ylabel('估计电压与电压均值偏离度', fontsize=24)
                    plt.xticks(df_time_data[0:(length-1):20],fontsize=20,rotation = 45)
                    plt.yticks(fontsize=20)
                    plt.title(title, fontsize=30)
                    plt.savefig(r'D:\Work\Code_write\data_analyze_platform\USER\lzx\01算法开发\05内阻及电压估计\02算法检测\判断结果\估计内阻\\'+title+'.png', dpi=300)
                for i in range(1,m):#m
                    df_time_data = []
                    fig = plt.figure(figsize=(20,10))
                    df_fig = df_del_vol_add.loc[df_del_vol_add['dischrgr_num'] == i]
                    df_fig.reset_index(drop = True, inplace = True)
                    length = len(df_fig)
                    df_time = pd.to_datetime(df_fig['时间戳'])
                    for df_time_num in range(0, length):
                        df_time_data.append(df_time[df_time_num].strftime('%H:%M:%S'))
                    for volt_num in cellvolt_name:
                        plt.plot(df_time_data, df_fig[volt_num],linewidth = 2, linestyle = '-', marker = 's',label=volt_num)
                    mpl.rcParams['font.sans-serif']=['SimHei']
                    mpl.rcParams['axes.unicode_minus']=False #用来正常显示负号
                    plt.legend(fontsize=18)
                    title = sn + '电压估计' + df_time[0].strftime('%Y-%m-%d') #df_fig['device_id'][0] + '-' + 
                    plt.xlabel('时间', fontsize=24)
                    plt.ylabel('估计电压与电压均值偏离度', fontsize=24)
                    plt.xticks(df_time_data[0:(length-1):20],fontsize=20,rotation = 45)
                    plt.yticks(fontsize=20)
                    plt.title(title, fontsize=30)
                    plt.savefig(r'D:\Work\Code_write\data_analyze_platform\USER\lzx\01算法开发\05内阻及电压估计\02算法检测\判断结果\估计电压\\'+title+'.png', dpi=300)
            if not df_diag_sor_add.empty:
                df_diag_sor = df_diag_sor.append(df_diag_sor_add)
                df_diag_sor = df_diag_sor.drop_duplicates(subset = ['sn','time'], keep = 'first', inplace = False)
                df_diag_sor.to_csv(r'D:\Work\Code_write\data_analyze_platform\USER\lzx\01算法开发\05内阻及电压估计\02算法检测\判断结果\内阻偏离.csv',index=False,encoding='GB18030')
            if not df_diag_vol_add.empty:
                df_diag_vol = df_diag_vol.append(df_diag_vol_add)
                df_diag_vol = df_diag_vol.drop_duplicates(subset = ['sn','time'], keep = 'first', inplace = False)
                df_diag_vol.to_csv(r'D:\Work\Code_write\data_analyze_platform\USER\lzx\01算法开发\05内阻及电压估计\02算法检测\判断结果\电压偏离.csv',index=False,encoding='GB18030')
            if not df_diag_sorvol_add.empty:
                df_diag_volsor = df_diag_volsor.append(df_diag_sorvol_add)
                df_diag_volsor = df_diag_volsor.drop_duplicates(subset = ['sn','time'], keep = 'first', inplace = False)
                df_diag_volsor.to_csv(r'D:\Work\Code_write\data_analyze_platform\USER\lzx\01算法开发\05内阻及电压估计\02算法检测\判断结果\电压内阻偏离.csv',index=False,encoding='GB18030')
        end=time.time()
        print(end-start)
        

#...............................................主函数...............................................................................................
if __name__ == "__main__":
    global SNnums
    global df_diag_sor
    global df_diag_vol
    global df_diag_volsor
    
    excelpath=r'D:\Work\Code_write\data_analyze_platform\USER\lzx\01算法开发\00项目sn号\sn-20210903.xlsx'
    SNdata_6060 = pd.read_excel(excelpath, sheet_name='科易6060')
    SNdata_6040 = pd.read_excel(excelpath, sheet_name='科易6040')
    SNdata_4840 = pd.read_excel(excelpath, sheet_name='科易4840')
    SNdata_L7255 = pd.read_excel(excelpath, sheet_name='格林美-力信7255')
    SNdata_C7255 = pd.read_excel(excelpath, sheet_name='格林美-CATL7255')
    SNdata_U7255 = pd.read_excel(excelpath, sheet_name='优旦7255')
    SNnums_6060=SNdata_6060['SN号'].tolist()
    SNnums_6040=SNdata_6040['SN号'].tolist()
    SNnums_4840=SNdata_4840['SN号'].tolist()
    SNnums_L7255=SNdata_L7255['SN号'].tolist()
    SNnums_C7255=SNdata_C7255['SN号'].tolist()
    SNnums_U7255=SNdata_U7255['SN号'].tolist()
    #SNnums=SNnums_L7255 + SNnums_C7255 + SNnums_6040 + SNnums_4840 + SNnums_U7255+ SNnums_6060
    # SNnums=['TJMCL120502305010','TJMCL120502305012','TJMCL120502305048','TJMCL120502305044','TJMCL120502305026','TJMCL120502305022','TJMCL120502305032','TJMCL120502305038']
    SNnums = ['PK504B00100004003'] #SNnums_6040 #SNnums_C7255 #SNnums_6040['MGMCLN750N215N049'] 
    # SNnums = pd.read_csv(r'D:\Work\Code_write\data_analyze_platform\USER\lzx\01算法开发\02析锂检测\liplated\疑似析锂电池sn.csv',encoding='GB18030')
    
    mylog=log.Mylog('log_diag.txt','error')
    mylog.logcfg()
    #............................模块运行前，先读取数据库中所有结束时间为0的数据，需要从数据库中读取................
    df_diag_sor = pd.read_csv(r'D:\Work\Code_write\data_analyze_platform\USER\lzx\01算法开发\05内阻及电压估计\02算法检测\判断结果\内阻偏离.csv',encoding='GB18030')
    df_diag_vol = pd.read_csv(r'D:\Work\Code_write\data_analyze_platform\USER\lzx\01算法开发\05内阻及电压估计\02算法检测\判断结果\电压偏离.csv',encoding='GB18030')
    df_diag_volsor = pd.read_csv(r'D:\Work\Code_write\data_analyze_platform\USER\lzx\01算法开发\05内阻及电压估计\02算法检测\判断结果\电压内阻偏离.csv',encoding='GB18030')
    
    print('----------------输入--------')
    print('-------计算中-----------')
    #定时任务.......................................................................................................................................................................
    scheduler = BlockingScheduler()
    scheduler.add_job(cell_volsor_test, 'interval', seconds=10, id='diag_job')

    try:  
        scheduler.start()
    except Exception as e:
        scheduler.shutdown()
        print(repr(e))
        mylog.logopt(e)